/*
 * Wii Classic controller to N64 adapter
 * Some controllers won't work because of the data format used.
 * Wire the Wii controller the same way as a wiichuck, using hardware spi.
 * Wire the N64 controller plug with data pin on D7
 * 
 * The arduino will report itself to the N64 as a controller with rumble.
 * Unfortunatly the Wii classic controller doesn't have rumble, so that part is removed.
 * Tested with official classic controller and 8bitdo nes classic bluetooth adapter.
 */

#include <avr/wdt.h>
#include <Wire.h>
#include <util/delay.h>
#include "n64.c"

#ifndef F_CPU
#define F_CPU 16000000 // 16MHz not sure if needed.
#endif

//unsigned long myCounter = 0;
bool connected;

void setup() {
    Serial.begin(9600);

  pinMode(6, OUTPUT); // classic detection LED
  // Communication with the N64 on this pin
  PORTE &=~ (1 << _BV(N64DATA)); // Pin n goes low
  DDRE |= (1 << _BV(N64DATA));        // PB0 Input
  init_classic();
}

void loop() {
  
    bool oldConnection = connected;
    update_classic();
    if(connected!=oldConnection){
      checkController(); 
    }
    digitalWrite(6, connected); // LED PIN
    wii_to_64();
    n64Stuff();
}

